import{s as be,n as $e,o as _e}from"../chunks/scheduler.182ea377.js";import{S as ve,i as ye,g as i,s as r,r as p,A as ze,h as s,f as n,c as a,j as H,u as c,x as I,k as M,y as m,a as o,v as h,d as b,t as $,w as _}from"../chunks/index.abf12888.js";import{D as re}from"../chunks/Docstring.93f6f462.js";import{H as j}from"../chunks/Heading.16916d63.js";function Ne(le){let l,k,V,F,v,O,y,fe="Customized normalization layers for supporting various models in 🤗 Diffusers.",R,z,U,f,N,ae,P,ue="Norm layer modified to incorporate timestep embeddings.",B,x,J,u,A,ie,G,ge="Norm layer adaptive layer norm zero (adaLN-Zero).",K,L,Q,d,T,se,S,pe="Norm layer adaptive layer norm single (adaLN-single).",de,D,ce='As proposed in PixArt-Alpha (see: <a href="https://arxiv.org/abs/2310.00426" rel="nofollow">https://arxiv.org/abs/2310.00426</a>; Section 2.3).',W,w,X,g,C,me,Z,he="GroupNorm layer modified to incorporate timestep embeddings.",Y,q,ee;return v=new j({props:{title:"Normalization layers",local:"normalization-layers",headingTag:"h1"}}),z=new j({props:{title:"AdaLayerNorm",local:"diffusers.models.normalization.AdaLayerNorm",headingTag:"h2"}}),N=new re({props:{name:"class diffusers.models.normalization.AdaLayerNorm",anchor:"diffusers.models.normalization.AdaLayerNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": int"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L28"}}),x=new j({props:{title:"AdaLayerNormZero",local:"diffusers.models.normalization.AdaLayerNormZero",headingTag:"h2"}}),A=new re({props:{name:"class diffusers.models.normalization.AdaLayerNormZero",anchor:"diffusers.models.normalization.AdaLayerNormZero",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": int"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormZero.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormZero.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L51"}}),L=new j({props:{title:"AdaLayerNormSingle",local:"diffusers.models.normalization.AdaLayerNormSingle",headingTag:"h2"}}),T=new re({props:{name:"class diffusers.models.normalization.AdaLayerNormSingle",anchor:"diffusers.models.normalization.AdaLayerNormSingle",parameters:[{name:"embedding_dim",val:": int"},{name:"use_additional_conditions",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormSingle.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormSingle.use_additional_conditions",description:"<strong>use_additional_conditions</strong> (<code>bool</code>) &#x2014; To use additional conditions for normalization or not.",name:"use_additional_conditions"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L82"}}),w=new j({props:{title:"AdaGroupNorm",local:"diffusers.models.normalization.AdaGroupNorm",headingTag:"h2"}}),C=new re({props:{name:"class diffusers.models.normalization.AdaGroupNorm",anchor:"diffusers.models.normalization.AdaGroupNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"out_dim",val:": int"},{name:"num_groups",val:": int"},{name:"act_fn",val:": typing.Optional[str] = None"},{name:"eps",val:": float = 1e-05"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaGroupNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_groups",description:"<strong>num_groups</strong> (<code>int</code>) &#x2014; The number of groups to separate the channels into.",name:"num_groups"},{anchor:"diffusers.models.normalization.AdaGroupNorm.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.models.normalization.AdaGroupNorm.eps",description:"<strong>eps</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-5</code>) &#x2014; The epsilon value to use for numerical stability.",name:"eps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L115"}}),{c(){l=i("meta"),k=r(),V=i("p"),F=r(),p(v.$$.fragment),O=r(),y=i("p"),y.textContent=fe,R=r(),p(z.$$.fragment),U=r(),f=i("div"),p(N.$$.fragment),ae=r(),P=i("p"),P.textContent=ue,B=r(),p(x.$$.fragment),J=r(),u=i("div"),p(A.$$.fragment),ie=r(),G=i("p"),G.textContent=ge,K=r(),p(L.$$.fragment),Q=r(),d=i("div"),p(T.$$.fragment),se=r(),S=i("p"),S.textContent=pe,de=r(),D=i("p"),D.innerHTML=ce,W=r(),p(w.$$.fragment),X=r(),g=i("div"),p(C.$$.fragment),me=r(),Z=i("p"),Z.textContent=he,Y=r(),q=i("p"),this.h()},l(e){const t=ze("svelte-u9bgzb",document.head);l=s(t,"META",{name:!0,content:!0}),t.forEach(n),k=a(e),V=s(e,"P",{}),H(V).forEach(n),F=a(e),c(v.$$.fragment,e),O=a(e),y=s(e,"P",{"data-svelte-h":!0}),I(y)!=="svelte-i4ltwe"&&(y.textContent=fe),R=a(e),c(z.$$.fragment,e),U=a(e),f=s(e,"DIV",{class:!0});var te=H(f);c(N.$$.fragment,te),ae=a(te),P=s(te,"P",{"data-svelte-h":!0}),I(P)!=="svelte-3m9blw"&&(P.textContent=ue),te.forEach(n),B=a(e),c(x.$$.fragment,e),J=a(e),u=s(e,"DIV",{class:!0});var ne=H(u);c(A.$$.fragment,ne),ie=a(ne),G=s(ne,"P",{"data-svelte-h":!0}),I(G)!=="svelte-hxuhdq"&&(G.textContent=ge),ne.forEach(n),K=a(e),c(L.$$.fragment,e),Q=a(e),d=s(e,"DIV",{class:!0});var E=H(d);c(T.$$.fragment,E),se=a(E),S=s(E,"P",{"data-svelte-h":!0}),I(S)!=="svelte-b3hofq"&&(S.textContent=pe),de=a(E),D=s(E,"P",{"data-svelte-h":!0}),I(D)!=="svelte-85nsxw"&&(D.innerHTML=ce),E.forEach(n),W=a(e),c(w.$$.fragment,e),X=a(e),g=s(e,"DIV",{class:!0});var oe=H(g);c(C.$$.fragment,oe),me=a(oe),Z=s(oe,"P",{"data-svelte-h":!0}),I(Z)!=="svelte-gj85yz"&&(Z.textContent=he),oe.forEach(n),Y=a(e),q=s(e,"P",{}),H(q).forEach(n),this.h()},h(){M(l,"name","hf:doc:metadata"),M(l,"content",xe),M(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){m(document.head,l),o(e,k,t),o(e,V,t),o(e,F,t),h(v,e,t),o(e,O,t),o(e,y,t),o(e,R,t),h(z,e,t),o(e,U,t),o(e,f,t),h(N,f,null),m(f,ae),m(f,P),o(e,B,t),h(x,e,t),o(e,J,t),o(e,u,t),h(A,u,null),m(u,ie),m(u,G),o(e,K,t),h(L,e,t),o(e,Q,t),o(e,d,t),h(T,d,null),m(d,se),m(d,S),m(d,de),m(d,D),o(e,W,t),h(w,e,t),o(e,X,t),o(e,g,t),h(C,g,null),m(g,me),m(g,Z),o(e,Y,t),o(e,q,t),ee=!0},p:$e,i(e){ee||(b(v.$$.fragment,e),b(z.$$.fragment,e),b(N.$$.fragment,e),b(x.$$.fragment,e),b(A.$$.fragment,e),b(L.$$.fragment,e),b(T.$$.fragment,e),b(w.$$.fragment,e),b(C.$$.fragment,e),ee=!0)},o(e){$(v.$$.fragment,e),$(z.$$.fragment,e),$(N.$$.fragment,e),$(x.$$.fragment,e),$(A.$$.fragment,e),$(L.$$.fragment,e),$(T.$$.fragment,e),$(w.$$.fragment,e),$(C.$$.fragment,e),ee=!1},d(e){e&&(n(k),n(V),n(F),n(O),n(y),n(R),n(U),n(f),n(B),n(J),n(u),n(K),n(Q),n(d),n(W),n(X),n(g),n(Y),n(q)),n(l),_(v,e),_(z,e),_(N),_(x,e),_(A),_(L,e),_(T),_(w,e),_(C)}}}const xe='{"title":"Normalization layers","local":"normalization-layers","sections":[{"title":"AdaLayerNorm","local":"diffusers.models.normalization.AdaLayerNorm","sections":[],"depth":2},{"title":"AdaLayerNormZero","local":"diffusers.models.normalization.AdaLayerNormZero","sections":[],"depth":2},{"title":"AdaLayerNormSingle","local":"diffusers.models.normalization.AdaLayerNormSingle","sections":[],"depth":2},{"title":"AdaGroupNorm","local":"diffusers.models.normalization.AdaGroupNorm","sections":[],"depth":2}],"depth":1}';function Ae(le){return _e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pe extends ve{constructor(l){super(),ye(this,l,Ae,Ne,be,{})}}export{Pe as component};
